
/*********************************************************************

Copyright (C) 1994, Lawrence Berkeley Laboratory.  All Rights
Reserved.  Permission to copy and modify this software and its
documentation (if any) is hereby granted, provided that this notice
is retained thereon and on all copies.  

This software is provided as a professional academic contribution
for joint exchange.   Thus it is experimental and scientific
in nature, undergoing development, and is provided "as is" with
no warranties of any kind whatsoever, no support, promise of
updates or printed documentation.

This work is supported by the U. S. Department of Energy under 
contract number DE-AC03-76SF00098 between the U. S. Department 
of Energy and the University of California.


	Author: Wes Bethel
		Lawrence Berkeley Laboratory

  "this software is 100% hand-crafted by a human being in the USA"

*********************************************************************/

#include <stdio.h>
#include <avs/avs.h>
#include <avs/field.h>
#include "vr_util.h"

AVSinit_modules()
{
    int Vr_2float();
    AVSmodule_from_desc(Vr_2float);
}

int
Vr_2float()
{
    int Vr_2float_compute();
    
    AVSset_module_name("VR to floats",MODULE_FILTER);
    AVScreate_input_port("input field",VR_FIELD_STRING,REQUIRED);
    AVScreate_output_port("X Translation","real");
    AVScreate_output_port("Y Translation","real");
    AVScreate_output_port("Z Translation","real");
    
    AVScreate_output_port("X Rotation","real");
    AVScreate_output_port("Y Rotation","real");
    AVScreate_output_port("Z Rotation","real");

    AVSset_compute_proc(Vr_2float_compute);
}

static float trans[3],rot[3];

int
Vr_2float_compute(inf,tx,ty,tz,rx,ry,rz)
AVSfield *inf;
float **tx,**ty,**tz;
float **rx,**ry,**rz;
{
    float *t;

    t = inf->field_union.field_data_float_u;
    
    VR_GET_TRANS_VECTOR(trans[0],trans[1],trans[2],inf); 
    *tx = trans;
    *ty = trans+1;
    *tz = trans+2;

    VR_GET_ROT_VECTOR(rot[0],rot[1],rot[2],inf); 
    *rx = rot;
    *ry = rot+1;
    *rz = rot+2;

    return(1);
}
